/*
 * AES encryption library.
 *
 * Velciu Veronica-Mihaela
 * 2017
 */

#ifndef __AES_H__
#define __AES_H__

#include "Arduino.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Encrypts a buffer in AES ECB mode using the given key. If len is not a multiple of 16,
 * the message will be truncated, so subsequent bytes will be lost. 
 */
void encryptECB(uint8_t *key, uint8_t *plaintext, uint8_t len, uint8_t *ciphertext);

/* Decrypts a buffer in AES ECB mode using the given key. If len is not a multiple of 16,
 * the ciphertext will be truncated. 
 */
void decryptECB(uint8_t *key, uint8_t *ciphertext, uint8_t len, uint8_t *plaintext);

/* Encrypts a buffer in AES CBC mode using the given key. If len is not a multiple of 16,
 * the message will be truncated, so subsequent bytes will be lost. 
 */
void encryptCBC(uint8_t *key, uint8_t *iv, uint8_t *plaintext, uint8_t len, uint8_t *ciphertext);

#ifdef __cplusplus
}
#endif

#endif /* __AES_H__ */
